<center><a href="ex19.c">Actual source code: ex19.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:26:11+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80">
<a name="line2">  2: </a>static char help[] = <font color="#666666">"Tests reusing MPI parallel matrices and <A href="../../../../docs/manualpages/Mat/MatGetValues.html#MatGetValues">MatGetValues</A>().\n\</font>
<a name="line3">  3: </a><font color="#666666">To test the parallel matrix assembly, this example intentionally lays out\n\</font>
<a name="line4">  4: </a><font color="#666666">the matrix across processors differently from the way it is assembled.\n\</font>
<a name="line5">  5: </a><font color="#666666">This example uses bilinear elements on the unit square.  Input arguments are:\n\</font>
<a name="line6">  6: </a><font color="#666666">  -m &lt;<A href="../../../../docs/manualpages/Sys/size.html#size">size</A>&gt; : problem <A href="../../../../docs/manualpages/Sys/size.html#size">size</A>\n\n"</font>;

<a name="line8"> 8: </a> #include <A href="../../../../include/petscmat.h.html">petscmat.h</A>

<a name="line12"> 12: </a><strong><font color="#4169E1"><a name="FormElementStiffness"></a>int FormElementStiffness(<A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> H,<A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A> *Ke)</font></strong>
<a name="line13"> 13: </a>{
<a name="line15"> 15: </a>  Ke[0]  = H/6.0;    Ke[1]  = -.125*H; Ke[2]  = H/12.0;   Ke[3]  = -.125*H;
<a name="line16"> 16: </a>  Ke[4]  = -.125*H;  Ke[5]  = H/6.0;   Ke[6]  = -.125*H;  Ke[7]  = H/12.0;
<a name="line17"> 17: </a>  Ke[8]  = H/12.0;   Ke[9]  = -.125*H; Ke[10] = H/6.0;    Ke[11] = -.125*H;
<a name="line18"> 18: </a>  Ke[12] = -.125*H;  Ke[13] = H/12.0;  Ke[14] = -.125*H;  Ke[15] = H/6.0;
<a name="line19"> 19: </a>  <font color="#4169E1">return</font>(0);
<a name="line20"> 20: </a>}

<a name="line24"> 24: </a><strong><font color="#4169E1"><a name="main"></a>int main(int argc,char **args)</font></strong>
<a name="line25"> 25: </a>{
<a name="line26"> 26: </a>  <A href="../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>            C;
<a name="line27"> 27: </a>  <A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>            u,b;
<a name="line29"> 29: </a>  <A href="../../../../docs/manualpages/Sys/PetscMPIInt.html#PetscMPIInt">PetscMPIInt</A>    <A href="../../../../docs/manualpages/Sys/size.html#size">size</A>,<A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A>;
<a name="line30"> 30: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,m = 5,N,start,end,M,idx[4];
<a name="line31"> 31: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       j,nrsub,ncsub,*rsub,*csub,mystart,myend;
<a name="line32"> 32: </a>  <A href="../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>     flg;
<a name="line33"> 33: </a>  <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    one = 1.0,Ke[16],*vals;
<a name="line34"> 34: </a>  <A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      h,norm;

<a name="line36"> 36: </a>  <A href="../../../../docs/manualpages/Sys/PetscInitialize.html#PetscInitialize">PetscInitialize</A>(&amp;argc,&amp;args,(char *)0,help);
<a name="line37"> 37: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsGetInt.html#PetscOptionsGetInt">PetscOptionsGetInt</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-m"</font>,&amp;m,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);

<a name="line39"> 39: </a>  N = (m+1)*(m+1); <font color="#B22222">/* dimension of matrix */</font>
<a name="line40"> 40: </a>  M = m*m;         <font color="#B22222">/* number of elements */</font>
<a name="line41"> 41: </a>  h = 1.0/m;       <font color="#B22222">/* mesh width */</font>
<a name="line42"> 42: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_rank.html#MPI_Comm_rank">MPI_Comm_rank</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;<A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A>);
<a name="line43"> 43: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_size.html#MPI_Comm_size">MPI_Comm_size</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;<A href="../../../../docs/manualpages/Sys/size.html#size">size</A>);

<a name="line45"> 45: </a>  <font color="#B22222">/* Create stiffness matrix */</font>
<a name="line46"> 46: </a>  <A href="../../../../docs/manualpages/Mat/MatCreate.html#MatCreate">MatCreate</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;C);
<a name="line47"> 47: </a>  <A href="../../../../docs/manualpages/Mat/MatSetSizes.html#MatSetSizes">MatSetSizes</A>(C,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,N,N);
<a name="line48"> 48: </a>  <A href="../../../../docs/manualpages/Mat/MatSetFromOptions.html#MatSetFromOptions">MatSetFromOptions</A>(C);

<a name="line50"> 50: </a>  start = <A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A>*(M/<A href="../../../../docs/manualpages/Sys/size.html#size">size</A>) + ((M%<A href="../../../../docs/manualpages/Sys/size.html#size">size</A>) &lt; <A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A> ? (M%<A href="../../../../docs/manualpages/Sys/size.html#size">size</A>) : <A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A>);
<a name="line51"> 51: </a>  end   = start + M/<A href="../../../../docs/manualpages/Sys/size.html#size">size</A> + ((M%<A href="../../../../docs/manualpages/Sys/size.html#size">size</A>) &gt; <A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A>);

<a name="line53"> 53: </a>  <font color="#B22222">/* Form the element stiffness for the Laplacian */</font>
<a name="line54"> 54: </a>  FormElementStiffness(h*h,Ke);
<a name="line55"> 55: </a>  <font color="#4169E1">for</font> (i=start; i&lt;end; i++) {
<a name="line56"> 56: </a>     <font color="#B22222">/* location of lower left corner of element */</font>
<a name="line57"> 57: </a>     <font color="#B22222">/* node numbers for the four corners of element */</font>
<a name="line58"> 58: </a>     idx[0] = (m+1)*(i/m) + (i % m);
<a name="line59"> 59: </a>     idx[1] = idx[0]+1; idx[2] = idx[1] + m + 1; idx[3] = idx[2] - 1;
<a name="line60"> 60: </a>     <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(C,4,idx,4,idx,Ke,<A href="../../../../docs/manualpages/Sys/ADD_VALUES.html#ADD_VALUES">ADD_VALUES</A>);
<a name="line61"> 61: </a>  }
<a name="line62"> 62: </a>  <A href="../../../../docs/manualpages/Mat/MatAssemblyBegin.html#MatAssemblyBegin">MatAssemblyBegin</A>(C,MAT_FINAL_ASSEMBLY);
<a name="line63"> 63: </a>  <A href="../../../../docs/manualpages/Mat/MatAssemblyEnd.html#MatAssemblyEnd">MatAssemblyEnd</A>(C,MAT_FINAL_ASSEMBLY);

<a name="line65"> 65: </a>  <font color="#B22222">/* Assemble the matrix again */</font>
<a name="line66"> 66: </a>  <A href="../../../../docs/manualpages/Mat/MatZeroEntries.html#MatZeroEntries">MatZeroEntries</A>(C);

<a name="line68"> 68: </a>  <font color="#4169E1">for</font> (i=start; i&lt;end; i++) {
<a name="line69"> 69: </a>     <font color="#B22222">/* location of lower left corner of element */</font>
<a name="line70"> 70: </a>     <font color="#B22222">/* node numbers for the four corners of element */</font>
<a name="line71"> 71: </a>     idx[0] = (m+1)*(i/m) + (i % m);
<a name="line72"> 72: </a>     idx[1] = idx[0]+1; idx[2] = idx[1] + m + 1; idx[3] = idx[2] - 1;
<a name="line73"> 73: </a>     <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(C,4,idx,4,idx,Ke,<A href="../../../../docs/manualpages/Sys/ADD_VALUES.html#ADD_VALUES">ADD_VALUES</A>);
<a name="line74"> 74: </a>  }
<a name="line75"> 75: </a>  <A href="../../../../docs/manualpages/Mat/MatAssemblyBegin.html#MatAssemblyBegin">MatAssemblyBegin</A>(C,MAT_FINAL_ASSEMBLY);
<a name="line76"> 76: </a>  <A href="../../../../docs/manualpages/Mat/MatAssemblyEnd.html#MatAssemblyEnd">MatAssemblyEnd</A>(C,MAT_FINAL_ASSEMBLY);

<a name="line78"> 78: </a>  <font color="#B22222">/* Create test vectors */</font>
<a name="line79"> 79: </a>  <A href="../../../../docs/manualpages/Vec/VecCreate.html#VecCreate">VecCreate</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;u);
<a name="line80"> 80: </a>  <A href="../../../../docs/manualpages/Vec/VecSetSizes.html#VecSetSizes">VecSetSizes</A>(u,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,N);
<a name="line81"> 81: </a>  <A href="../../../../docs/manualpages/Vec/VecSetFromOptions.html#VecSetFromOptions">VecSetFromOptions</A>(u);
<a name="line82"> 82: </a>  <A href="../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(u,&amp;b);
<a name="line83"> 83: </a>  <A href="../../../../docs/manualpages/Vec/VecSet.html#VecSet">VecSet</A>(u,one);

<a name="line85"> 85: </a>  <font color="#B22222">/* Check error */</font>
<a name="line86"> 86: </a>  <A href="../../../../docs/manualpages/Mat/MatMult.html#MatMult">MatMult</A>(C,u,b);
<a name="line87"> 87: </a>  <A href="../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(b,<A href="../../../../docs/manualpages/Vec/NORM_2.html#NORM_2">NORM_2</A>,&amp;norm);
<a name="line88"> 88: </a>  <font color="#4169E1">if</font> (norm &gt; 1.e-10 || norm &lt; -1.e-10) {
<a name="line89"> 89: </a>    <A href="../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,<font color="#666666">"Norm of error b %G should be near 0\n"</font>,norm);
<a name="line90"> 90: </a>  }

<a name="line92"> 92: </a>  <font color="#B22222">/* Now test <A href="../../../../docs/manualpages/Mat/MatGetValues.html#MatGetValues">MatGetValues</A>() */</font>
<a name="line93"> 93: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsHasName.html#PetscOptionsHasName">PetscOptionsHasName</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-get_values"</font>,&amp;flg);
<a name="line94"> 94: </a>  <font color="#4169E1">if</font> (flg) {
<a name="line95"> 95: </a>    <A href="../../../../docs/manualpages/Mat/MatGetOwnershipRange.html#MatGetOwnershipRange">MatGetOwnershipRange</A>(C,&amp;mystart,&amp;myend);
<a name="line96"> 96: </a>    nrsub = myend - mystart; ncsub = 4;
<a name="line97"> 97: </a>    <A href="../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(nrsub*ncsub*<font color="#4169E1">sizeof</font>(<A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>),&amp;vals);
<a name="line98"> 98: </a>    <A href="../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(nrsub*<font color="#4169E1">sizeof</font>(<A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;rsub);
<a name="line99"> 99: </a>    <A href="../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(ncsub*<font color="#4169E1">sizeof</font>(<A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;csub);
<a name="line100">100: </a>    <font color="#4169E1">for</font> (i=myend-1; i&gt;=mystart; i--) rsub[myend-i-1] = i;
<a name="line101">101: </a>    <font color="#4169E1">for</font> (i=0; i&lt;ncsub; i++) csub[i] = 2*(ncsub-i) + mystart;
<a name="line102">102: </a>    <A href="../../../../docs/manualpages/Mat/MatGetValues.html#MatGetValues">MatGetValues</A>(C,nrsub,rsub,ncsub,csub,vals);
<a name="line103">103: </a>    <A href="../../../../docs/manualpages/Mat/MatView.html#MatView">MatView</A>(C,<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_WORLD.html#PETSC_VIEWER_STDOUT_WORLD">PETSC_VIEWER_STDOUT_WORLD</A>);
<a name="line104">104: </a>    <A href="../../../../docs/manualpages/Sys/PetscSynchronizedPrintf.html#PetscSynchronizedPrintf">PetscSynchronizedPrintf</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,<font color="#666666">"processor number %d: start=%D, end=%D, mystart=%D, myend=%D\n"</font>,
<a name="line105">105: </a>            <A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A>,start,end,mystart,myend);
<a name="line106">106: </a>    <font color="#4169E1">for</font> (i=0; i&lt;nrsub; i++) {
<a name="line107">107: </a>      <font color="#4169E1">for</font> (j=0; j&lt;ncsub; j++) {
<a name="line108">108: </a><font color="#A020F0">#if defined(PETSC_USE_COMPLEX)</font>
<a name="line109">109: </a>        <font color="#4169E1">if</font> (PetscImaginaryPart(vals[i*ncsub+j]) != 0.0) {
<a name="line110">110: </a>           <A href="../../../../docs/manualpages/Sys/PetscSynchronizedPrintf.html#PetscSynchronizedPrintf">PetscSynchronizedPrintf</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,<font color="#666666">"  C[%D, %D] = %G + %G i\n"</font>,rsub[i],csub[j],PetscRealPart(vals[i*ncsub+j]),
<a name="line111">111: </a>                                       PetscImaginaryPart(vals[i*ncsub+j]));
<a name="line112">112: </a>        } <font color="#4169E1">else</font> {
<a name="line113">113: </a>           <A href="../../../../docs/manualpages/Sys/PetscSynchronizedPrintf.html#PetscSynchronizedPrintf">PetscSynchronizedPrintf</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,<font color="#666666">"  C[%D, %D] = %G\n"</font>,rsub[i],csub[j],PetscRealPart(vals[i*ncsub+j]));
<a name="line114">114: </a>        }
<a name="line115">115: </a><font color="#A020F0">#else</font>
<a name="line116">116: </a>         <A href="../../../../docs/manualpages/Sys/PetscSynchronizedPrintf.html#PetscSynchronizedPrintf">PetscSynchronizedPrintf</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,<font color="#666666">"  C[%D, %D] = %G\n"</font>,rsub[i],csub[j],vals[i*ncsub+j]);
<a name="line117">117: </a><font color="#A020F0">#endif</font>
<a name="line118">118: </a>      }
<a name="line119">119: </a>    }
<a name="line120">120: </a>    <A href="../../../../docs/manualpages/Sys/PetscSynchronizedFlush.html#PetscSynchronizedFlush">PetscSynchronizedFlush</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>);
<a name="line121">121: </a>    <A href="../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(rsub);
<a name="line122">122: </a>    <A href="../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(csub);
<a name="line123">123: </a>    <A href="../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(vals);
<a name="line124">124: </a>  }

<a name="line126">126: </a>  <font color="#B22222">/* Free data structures */</font>
<a name="line127">127: </a>  <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(u);
<a name="line128">128: </a>  <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(b);
<a name="line129">129: </a>  <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(C);
<a name="line130">130: </a>  <A href="../../../../docs/manualpages/Sys/PetscFinalize.html#PetscFinalize">PetscFinalize</A>();
<a name="line131">131: </a>  <font color="#4169E1">return</font> 0;
<a name="line132">132: </a>}


</pre>
</body>

</html>
